// this script takes an URL as a parameter, converts it into PUTTY executable parameters, and executes
// it tries to find putty in Program Files; if you use a custom location please change.

var url = WScript.Arguments(0);

var shell = new ActiveXObject("WScript.shell");
var fso = new ActiveXObject("Scripting.FileSystemObject");

function TryRunPutty(pf) {
	var path = shell.ExpandEnvironmentStrings(pf) + "\\PuTTY\\putty.exe"

	// if PuTTY executable found
	if (fso.FileExists(path)) {

		// break the passed in URL into parts
		var pattern = RegExp("^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?");
		var matches = url.match(pattern);
		var args = {
			scheme: matches[2],
			authority: matches[4],
			path: matches[5],
			query: matches[7],
			fragment: matches[9],
			params: {}
		};

		// split the passed in parameters string
		var regex = /[?&]([^=#]+)=([^&#]*)/g,
			match;

		while (match = regex.exec(url)) {
			args.params[match[1]] = match[2];
		}

		// start the PuTTY executable
		shell.Run('"' + path + '" ' + args.authority);
		WScript.Quit(0);
	}
}

TryRunPutty("%PROGRAMW6432%")
TryRunPutty("%PROGRAMFILES(x86)%")
TryRunPutty("%PROGRAMFILES%")

WScript.Echo("Could find PuTTY in program files. Please make sure it is installed.\nIf installed then please make sure this script can find it: " + WScript.ScriptFullName)
